//Bezier intersections
//https://www.shadertoy.com/view/WtVfRy

// Idea from http://truetex.com/bezint.htm

float n(float i) {
  return 3.*sin(iTime*(0.2+0.5*sin(i*.0001))+i);
}
float bezier(float t, float a, float b, float c, float d) {
  float q = 1.0-t;
  return q*q*q*n(a) + 
        3.*q*q*t*n(b) + 
          3.*q*t*t*n(c) + 
               t*t*t*n(d);
}
float color(vec2 uv, float off) {
  vec2 a = vec2(
    bezier(uv.x, 1., -2. + off, 8., -4.),
    bezier(uv.x, 9., -9., 7., -6.)
  );
  vec2 b = vec2(
    bezier(uv.y, 5., 2., 5., -5.),
    bezier(uv.y, -1., -3., 8., 9.)
  );
  return distance(a, b);
}
void mainImage( out vec4 fragColor, in vec2 fragCoord ) {
    vec2 uv = fragCoord/iResolution.xy;
    vec3 c = vec3(color(uv, .3), color(uv, .01), color(uv, .02));  
    vec3 col = vec3(1.0/(1.0+c*8.0));
    fragColor = vec4(col, 1.0);
}