//https://www.shadertoy.com/view/fsKXDm

#define MAX_STEPS 50
#define MAX_DIST 100.
#define MIN_DIST 0.1
float HALF = 0.5;
float PIH = 1.57079632679;
float PI  = 3.14159265359;
float TAU = 6.28318530718;
float E = 2.71828182846;
float RADIUS = 6.;
vec4 sphere = vec4(0.,1.,0.,1.);
vec3 lightpos = vec3(10.,10.,6.);

float getdist(vec3 raypos)
{
    float planedist = raypos.y - texture(iChannel0,raypos.xz *0.01).x*0.5;
    float spheredist = length(raypos-vec3(0.,1.,0.))-1.;
    float spheredist2 = length(raypos-vec3(0.,2.2 + 1. + 0.5 *sin(iTime * .25),sin(iTime * .5)))-.6;
    float spheredist3 = length(raypos-vec3(0.,3.5 - sin(iTime * .125),-1.))-.2;
    float dist = min(planedist,spheredist);
    dist =min(dist,spheredist2);
    dist =min(dist,spheredist3);
    return smoothstep(0.,3.,dist);
}
vec3 getnormal(vec3 p)
{
 	return normalize(sphere.xyz-p);   
}
float getlight(vec3 p)
{
    vec3 lightdir = normalize(lightpos-p);
    vec3 normal = getnormal(p);
    float diff = dot(normal,lightdir);
    return diff;
}
float raymarch(vec3 camera, vec3 dir)
{
	float dist = 0.; 
    for(int i=0; i<MAX_STEPS; i++){
   		vec3 pos = camera+dir*dist;
        float stepdist = getdist(pos);
        dist+=stepdist;
        if(dist>MAX_DIST || dist<MIN_DIST) break;
    }
    return dist;
}
void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = (fragCoord-iResolution.xy*HALF)/iResolution.y;
    vec3 col = vec3(0.);
    float time = iTime * 0.1;
	
    vec3 camera = vec3(sin(time -PIH) * RADIUS,2. +sin(time),cos(time -PIH) * RADIUS);
    vec3 ray = vec3(sin(time) * uv.x + cos(time), uv.y - sin(time)*0.2,cos(time)*uv.x - sin(time));
    float d = raymarch(camera, normalize(ray));
    vec3 p = camera + ray*d;
    float diff = getlight(p);
    col+=vec3(1.-diff);
    col = col *.4;
    
    
    
    fragColor = vec4(mix(vec3(.05,-.1,.1),vec3(1.5,.7,-.6),col),1.0);
}