//https://www.shadertoy.com/view/7sVSW1
#define complex vec2
// z.s is real part; z.t is imaginary part

const float infinity = 100000.0;
const int maxSteps = 50;

vec2 rot(vec2 p, float a) {
    float s = sin(a);
    float c = cos(a);
    return vec2 (
        c*p.x - s*p.y,
        s*p.x + c*p.y
    );
}

complex pow2(complex z) {
    return complex(z.s*z.s - z.t*z.t, 2.0*z.s*z.t);
}


void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = ( 2.0*fragCoord - iResolution.xy ) / iResolution.y;
    vec2 m = ( 2.0*iMouse.xy - iResolution.xy ) / iResolution.y;

    complex z = uv * 2.0;
    complex c = complex(1.0, 0.8);
    c = rot(c, iTime * 0.2);
    
    int i = 0;
    for (; i < maxSteps; i++) {
        z = pow2(z) + c;
        if (z.s >= infinity || z.t >= infinity)
            break;
    }    
    
    vec3 col = mix(vec3(0.0), vec3(1.0), vec3(float(i) / float(maxSteps)));
    
    
    fragColor = vec4(col, 1.0);
}