// https://www.shadertoy.com/view/ddtfD4

#define TAU 6.2831853071

void mainImage(out vec4 fragColor, in vec2 fragCoord) {
	vec2 uv = fragCoord.xy / iResolution.xy;
    
    vec2 center = vec2(0.5, 0.5);

    // Calculate the distance from the current fragment to the center
    float distanceToCenter = distance(uv, center) * 1.8  + sin((iTime * 0.05) * TAU) * .075 + cos((iTime * 0.05) * TAU) * .045;

    float v = distanceToCenter;

    // Modify the effect based on the circular position
    v = 1.0 - abs(v * 2.0 - 1.0);
    v = pow(v, 4.0 + sin((iTime * 0.3 + v * 0.25) * TAU) * 0.75);


    vec3 color = vec3(0.0);
    
    float x = (1.0 - uv.x * 0.75);
    float y = 1.00 - abs(uv.y * 2.0 - 1.0 + sin((iTime * 0.13 + v * 0.25) * TAU));
    color += vec3(x * 0.5, y, x) * v;
    
    fragColor.rgb = color;
    fragColor.a = .2;
    
}