// https://www.shadertoy.com/view/fdjfDc

#define SCALE 2.0
#define R iResolution.xy
#define PI radians(180.0)
#define TAU (PI*2.0)
#define CL(x,a,b) smoothstep(0.0,1.0,(2.0/3.0)*(x-a)/(b-a)+(1.0/6.0))*(b-a)+a // https://www.shadertoy.com/view/Ws3Xzr
void mainImage( out vec4 O, in vec2 U )
{
    vec4 m = iMouse; m.xy = (m.xy-0.5*R.xy)/R.y*2.0; // mouse to cartesian
    float st = radians(-31.0); // start position (180 = inf)
    float t = (m.z > 0.0) ? atan(m.x, -m.y): st+(iTime*TAU)/3600.0; // #sec for num line
    float n = (cos(t) > 0.0) ? sin(t): 1.0/sin(t); // time to sin/csc
    float az = pow(500.0, n); // autozoom
    az = clamp(az, CL(az, 1e-16, 1e-15), CL(az, 1e+17, 1e+18)); // clamp at precision lost
    vec2 uv = (U-0.5*R)/R.y*SCALE*az; // apply cartesian, scale, zoom
    vec3 c = vec3(0); // black background
    float a = atan(uv.x, -uv.y); // arc radian
    float i = a/TAU; // spiral increment 0.5 per 180°
    float l = pow(length(uv), 0.5/n); // logarithmic (archimedean at 0.5)
    float r = l-i; // spiral radius
    float ls = (iTime*TAU)/5.0; // light animation speed
    c += sin(ls+pow(TAU*ceil((TAU*l-a)/TAU)+a, 2.0)/(2.0*TAU*n)); // segmented spiral magic
    c *= pow(sin(fract(r)*PI), abs(n*2.0)+5.0); // smooth edges & thin near inf
    float vd = (ceil(r)*TAU+a)/n; // visual denominator
    c *= sin(vd*(ceil(r)+i)+PI/2.0+ls*2.0); // this looks nice
    c *= 0.2+abs(cos(vd)); // dark spirals
    c = min(c, pow(length(uv)/az, -1.0/n)); // dark gradient
    vec3 rgb = vec3(cos(vd)+1.0, abs(sin(t)), cos(PI+vd)+1.0); // color
    c += (c*2.0)-(rgb*0.5); // add color
    if (m.z > 0.0) c = digitIn(c, vec3(1), (U-0.5*R)/R.y*2.0-m.xy, 44.0, n); // digits
    O = vec4(c, 1.0);
}