//  https://www.shadertoy.com/view/tscSz7
#define DOTS 24
#define DOTOFFSET 0.04
#define SPEED 0.05
#define POWER 7.
#define COLTOP vec3(.3,0.6,1.)
#define COLBTM vec3(1.,.4,.3)

#define lerp mix
#define pi 3.1415

float smin( float a, float b, float k )
{
    float h = clamp( 0.5+0.5*(b-a)/k, 0.0, 1.0 );
    return mix( b, a, h ) - k*h*(1.0-h);
}

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = fragCoord/iResolution.xy-.5;
    uv.x*=iResolution.x/iResolution.y;

    float d = 9999.;
    vec3 col;
    for (int i=0;i<DOTS;i++) {
    	float t = pow(fract(iTime*SPEED+(float(i)*DOTOFFSET)),POWER);
    	float s = pi*2.;
    	vec2 o = vec2(sin(t*s), cos(t*s))*.2;
        float dist = length(uv+o)-.01;
        if (dist<d){
        	col=lerp(COLTOP,COLBTM, cos(t*s)*.5+.5);
        }
    	d = smin(d,dist, 0.04);
        
        
    }
    
    
    
    col = lerp(col, vec3(.02,.02,.08), smoothstep(0., 0.007, d));

    // Output to screen
    fragColor = vec4(col,1.0);
}