//https://www.shadertoy.com/view/sscXD7

//ADJUST THESE as you like
#define SPARKLESPEED .05
#define ROTATIONSPEED .01
#define MOVEMENTSPEED .05

#define LAYERZOOM 10.
#define LAYERMOVEMENTSPEED 0.01

#define BGCOLOR vec3(0.020, 0.23, 0.300) * .01

#define FGCOLOR vec3(0.475, 0.696, 0.702) * .2

//DON'T TOUCH THE REST :)

mat2 Rot(float a) {
   float s=sin(a), c=cos(a);
   return mat2(c,s,-s,c);
}


float Hash21(vec2 p) {
    p = fract(p * vec2(123.21, 552.53));
    p += dot(p, p+34.21);
    return fract(p.x * p.y);
}

vec2 Hash22(vec2 p) {
   vec3 p3 = fract(vec3(p.xyx) * vec3(231.23,423.24, 521.23));
   p3 += dot(p3, p3.yzx + 23.42);
   return fract((p3.xx + p3.zy) * p3.zy);
}

float DistanceFromLine( in vec2 a, in vec2 b, in vec2 p) {
    vec2 pa = p - a, ba = b - a;
	float h = clamp(dot(pa,ba) / dot(ba,ba), 0., 1.);	
	return length(pa - ba * h);
}

float SimpleLine(vec2 a, vec2 b, vec2 uv) {
    float d = DistanceFromLine(a, b, uv);
    float m = smoothstep(.03, .01, d);
    m*=smoothstep(1.2, .8, length(a-b));
    return m;
}


vec2 GetPos(vec2 id, vec2 offs) {
    vec2 n = Hash22(id + offs) * (223.23 + iTime * MOVEMENTSPEED);
    return offs + sin(n) * .4;
}


float Layer(vec2 uv, float n) {
    uv *= Rot(n * 20. + iTime * ROTATIONSPEED);
    vec2 gv = fract(uv)-.5;
    vec2 id = floor(uv);
    
    
    vec2 p[9];
    int i=0;
    for (float y=-1.;y<=1.;y++) {
        for (float x=-1.;x<=1.;x++) {
            p[i++] = GetPos(id, vec2(x,y));// + Hash22(id - offs) * 0.5 * Rot(iTime * Hash21(id - offs) * 0.5);
        }
    }
    
    float m = 0.;
    for (i = 0; i<9; i++) {
        
        vec2 j = (p[i] - gv) * 30.;
        float sparkle = 1./dot(j,j);
        m+=sparkle * (sin(iTime * SPARKLESPEED + (Hash21(p[i]) )) * .5 + .5);
        
        m += SimpleLine(p[4], p[i], gv);
    }
    m+= SimpleLine(p[1], p[3], gv);
    m+= SimpleLine(p[1], p[5], gv);
    m+= SimpleLine(p[7], p[3], gv);
    m+= SimpleLine(p[7], p[5], gv);
    
    return m;
}

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = (fragCoord-.5*iResolution.xy)/iResolution.y;
   
    float t = iTime * LAYERMOVEMENTSPEED;
    
    float m = 0.;
    for (float i=0.; i<1.; i+=1./4.) {
        float z = fract(t + i);
        float size = mix(LAYERZOOM, 1., z);
        float fade = smoothstep(0., .6, z) * smoothstep(1., .8, z);
        m += Layer(uv * size, i) * fade;
    }
    
    //vec3 currentCol = vec3(sin(iTime) * 0.5 + 0.5,cos(iTime) * 0.5 + 0.5,.9);
    //m = mix(m, .1, smoothstep(.0, 2.0, (fft-uv.y)));
    vec3 currentCol = m * FGCOLOR + (1. - m) * BGCOLOR;
    vec3 col =  currentCol;
    
    
    //col = (1.-step(.5, length(uv))) * col;
    //col = i.xyz;

    
    //col = smoothstep(.5, .3, length(uv) - fft) * vec3(1.);
    
    fragColor = vec4(col,1.0);
}